

//******************************************************************//
//																	//
//				(C) 2017 R-MIK Sawomir Skrzyski					//
//				slawomir.skrzynski@ep.com.pl						//
//																	//
//	Programu nie mona rozpowszechnia bez pisemnej zgody autora!	//
//																	//
//******************************************************************//


#include "Live.h"


//----------------------------------------------------------------------//
void LiveTimeCount( byte Init )
{
word static DzielnikSekund=1;


	if ( Init )									// Jeli init to odczytaj dane z eeprom
		{
		if ( eeprom_read_word( &EEtLiveMatch ) != LIVEMATCH )
			{
			tLiveFlag = FALSE;
			return;
			}
		if ( LiveTimeReadEE() )					// Jesli wynik false to ustaw flage zaprzestania zliczania i wyjdz
			{
			tLiveFlag = FALSE;
			return;
			}
		if ( tLiveMatch != LIVEMATCH )			// Jeli sekndy i minuty nie ma w ram
			{									// to przypisz wartoci domylne
			tLiveMatch = LIVEMATCH;
			tLiveSec =  LIFESEC;
			tLiveMin = LIFEMIN;
nop();
			}
		}


	if ( -- DzielnikSekund ) return;
	DzielnikSekund = 1000;						// Dzielnik dla uzyskania sekund

	if ( !tLiveFlag ) return;					// jeli licznie zakoczone to wyjd

	if ( tLiveSec ) { tLiveSec--; }				// Odliczaj Sekundy
	else{ tLiveSec = 59;
		if ( tLiveMin ) { tLiveMin--; }			// Odliczaj Minuty
		else{ tLiveMin = 59;					// *** Zapis eeprom co godzin
			tLiveWrEEfl = TRUE;
			if ( tLiveHour ) { tLiveHour--; }	// Odliczaj Godziny
			else{ tLiveHour = 23;
				if ( tLiveDay ) { tLiveDay--; }	// Odliczaj Dni
				else{ //tLiveDay = 364;			// *** Koniec odliczania
					tLiveFlag = FALSE;
					tLiveWrEEfl = TRUE;
					eeprom_write_byte( &EEtLiveFlag, FALSE );
nop();
					}
				}
			}
		}

}


//----------------------------------------------------------------------//
byte LiveTimeTest()
{
	if ( tLiveWrEEfl )		// Test znacznika zapisu eeprom (tego co godzia)
		{
		tLiveWrEEfl = FALSE;
		LiveTimeWriteEE();
		}


	return ( tLiveFlag );
}


//----------------------------------------------------------------------//
void LiveTimeWriteEE()
{
static word crc=0xFFFF;


	eeprom_write_word( &EEtLiveMatch, LIVEMATCH );	crc = LiveTimeCrc( crc, LIVEMATCH & 0xFF ); LiveTimeCrc( crc, LIVEMATCH >> 8 );
	eeprom_write_byte( &EEtLiveFlag, tLiveFlag );	crc = LiveTimeCrc( crc, tLiveFlag );
	eeprom_write_byte( &EEtLiveHour, tLiveHour );	crc = LiveTimeCrc( crc, tLiveHour );	// Starczy na ponad 10lat przy dopuszczalnych 10.000 zapisach
	eeprom_write_byte( &EEtLiveDay, tLiveDay );		crc = LiveTimeCrc( crc, tLiveDay );
	if ( crc == LIVEMATCH ) crc++;		// CRC nie moe byc wartoci LIVEMATCH
	eeprom_write_word( &EEtLiveCrc, crc );
nop();


	eeprom_write_word( &EEtLiveMatch_bak, LIVEMATCH );
	eeprom_write_byte( &EEtLiveFlag_bak, tLiveFlag );
	eeprom_write_byte( &EEtLiveHour_bak, tLiveHour );
	eeprom_write_byte( &EEtLiveDay_bak, tLiveDay );
	eeprom_write_word( &EEtLiveCrc_bak, crc );
nop();
}


//----------------------------------------------------------------------//
byte LiveTimeReadEE()
{
word crc=0xFFFF, crcEE, mathEE;


	mathEE = eeprom_read_word( &EEtLiveMatch );		crc = LiveTimeCrc( crc, mathEE );
	tLiveFlag = eeprom_read_byte( &EEtLiveFlag );	crc = LiveTimeCrc( crc, tLiveFlag );
	tLiveHour = eeprom_read_byte( &EEtLiveHour );	crc = LiveTimeCrc( crc, tLiveHour );
	tLiveDay = eeprom_read_byte( &EEtLiveDay ); 	crc = LiveTimeCrc( crc, tLiveDay );
	crcEE= eeprom_read_word( &EEtLiveCrc );
	if ( crcEE==LIVEMATCH ) LiveTimeWriteEE();		// Jeli warto startowa CRC dokonaj zapisu
	if ( crc == crcEE) return( TRUE);


	//----- Odtworzenie z drugiej kopi -----//
	mathEE = eeprom_read_word( &EEtLiveMatch_bak );		crc = LiveTimeCrc( crc, mathEE );
	tLiveFlag = eeprom_read_byte( &EEtLiveFlag_bak );	crc = LiveTimeCrc( crc, tLiveFlag );
	tLiveHour = eeprom_read_byte( &EEtLiveHour_bak );	crc = LiveTimeCrc( crc, tLiveHour );
	tLiveDay = eeprom_read_byte( &EEtLiveDay_bak ); 	crc = LiveTimeCrc( crc, tLiveDay );
	crcEE= eeprom_read_word( &EEtLiveCrc_bak );
	if ( crc == crcEE) return( TRUE);


	return( FALSE );
}


//----------------------------------------------------------------------//
word LiveTimeCrc( byte crc, byte data )
{
    return( _crc16_update( crc, data) );

/** \ingroup util_crc
    Optimized CRC-16 calculation.

    Polynomial: x^16 + x^15 + x^2 + 1 (0xa001)<br>
    Initial value: 0xffff

    This CRC is normally used in disk-drive controllers.

    The following is the equivalent functionality written in C.

    \code
    uint16_t
    crc16_update(uint16_t crc, uint8_t a)
    {
	int i;

	crc ^= a;
	for (i = 0; i < 8; ++i)
	{
	    if (crc & 1)
		crc = (crc >> 1) ^ 0xA001;
	    else
		crc = (crc >> 1);
	}

	return crc;
    }

    \endcode */
}


//----------------------------------------------------------------------//
