

//******************************************************************//
//																	//
//				(C) 2017 R-MIK Sawomir Skrzyski					//
//				slawomir.skrzynski@ep.com.pl						//
//																	//
//	Programu nie mona rozpowszechnia bez pisemnej zgody autora!	//
//																	//
//******************************************************************//


#include <rmik/onewire search.h>


//#define	OWSEARCHTEST


//--------------------------------------------------------------------------
// Find the 'first' devices on the 1-Wire bus
// Return TRUE : device found, ROM number in OW_SEARCH_ROM_NO buffer
// FALSE : no device present
//
// onewireMany		TRUE to conajmniej dwa ukady na magistrali
// onewireCount		Liczba znalezionych ukadw, prawdziwe gdy "OWNext" zwrci FALSE
unsigned char OWFirst()
{
	OWFi();						// reset the search state, ustawia standardow prdko trnsmisji
	return OWSearch( FALSE );	// FALSE - szukamy wszystkich ukadw
}


//------------------------//
unsigned char OWFirstOVD()		// Szuka pierwszego ukadu obsugujcego overdrive
{
//
#warning "nie testowane "
//todo: NIE TESTOWANE !!!
	OWFi();						// reset the search state, ustawia standardow prdko trnsmisji

	if ( onewireResetSTD() )	//reset
		{
		onewireWriteByte(ONEWIRE_OVD_SKIPROM);
		onewriteOverdriveOnOff( TRUE );// Tryb overdrive
		}
	else						// Nic nie ma na magistrali
		{
		return( TRUE );
		}


	return OWSearch( FALSE );	// FALSE - szukamy wszystkich ukadw (tryb overdrive)
}


//------------------------//
unsigned char OWFirstAlert()	// Szuka pierwszego ukadu z alarmem
{
	OWFi();						// reset the search state, ustawia standardow prdko trnsmisji
	return OWSearch( TRUE );	// TRUE - szukamy alarmw
}


//------------------------//
void OWFi()						// Pomocnicza dla "OWFirstXXXXXXX"
{
	onewriteOverdriveOnOff( FALSE );	// Standardowa prdko trnsmisji
	onewireMany = FALSE;
	onewireCount = 0;
	// reset the search state
	LastDiscrepancy = 0;
	LastDeviceFlag = FALSE;
	LastFamilyDiscrepancy = 0;
}


//--------------------------------------------------------------------------
// Find the 'next' devices on the 1-Wire bus
// Return TRUE : device found, ROM number in OW_SEARCH_OW_SEARCH_ROM_NO buffer
// FALSE : device not found, end of search
//
// onewireMany		TRUE to conajmniej dwa ukady na magistrali
// onewireCount		Liczba znalezionych ukadw, prawdziwe gdy "OWNext" zwrci FALSE
unsigned char OWNext()
{
	// leave the search state alone
	return OWSearch( FALSE );	// FALSE - szukamy wszystkich ukadw
}


//-----------------------//
unsigned char OWNextAlert()
{
	// leave the search state alone
	return OWSearch( TRUE );	// TRUE - szukamy alarmw
}


//--------------------------------------------------------------------------
unsigned int OWHowMuch()
{
unsigned char result=FALSE;


	result = OWFirst();
	while( result ) { wdt_reset(); result = OWNext(); }
	return( onewireCount );
}


//-------------------------//
unsigned int OWHowMuchAlert()
{
unsigned char result=FALSE;


	result = OWFirstAlert();
	while( result ) { wdt_reset(); result = OWNextAlert(); }
	return( onewireCount );
}


//--------------------------------------------------------------------------
// Perform the 1-Wire Search Algorithm on the 1-Wire bus using the existing
// search state.
// Return TRUE : device found, ROM number in OW_SEARCH_ROM_NO buffer
// FALSE : device not found, end of search
//
unsigned char OWSearch( byte alarm )
{
unsigned char id_bit_number;
unsigned char last_zero, rom_byte_number, search_result;
unsigned char id_bit, cmp_id_bit;
unsigned char rom_byte_mask, search_direction;


	#if ONEWIRE_IRQ == 2 || ONEWIRE_IRQ == 1
	  uint8_t cSREG;
	  cSREG = SREG; cli();
	#endif

	// initialize for search
	id_bit_number = 1;
	last_zero = 0;
	rom_byte_number = 0;
	rom_byte_mask = 1;
	search_result = 0;
	crc8 = 0;
	// if the last call was not the last one
	if ( !LastDeviceFlag )
		{
		// 1-Wire reset				// Rozpoczcie szukania
		if ( !onewireResetSTD() )
			{						// Brak potwierdzenia obecnoci ukadw
			// reset the search
			LastDiscrepancy = 0;
			LastDeviceFlag = FALSE;
			LastFamilyDiscrepancy = 0;
#ifdef OWSEARCHTEST
#warning "Komunikaty testowe w search 1-Wire."
  LenTx1=1; UDR1='R'; // TEST
#endif
			onewireReset();
			#if ONEWIRE_IRQ == 2 || ONEWIRE_IRQ == 1
			  SREG = cSREG;
			#endif
			return FALSE;
			}
		// Ukad(y) potwiedziy(y) obecno, rozpoczcie wyszukiwania
		// issue the search command
		if ( alarm )
			{
			onewireWriteByte( ONEWIRE_CMD_ALARMSEARCH );
			}
		else
			{
			onewireWriteByte( ONEWIRE_CMD_SEARCHROM );
			}

#ifdef OWSEARCHTEST
  LenTx1=1; UDR1=' ' UDR1='f'; // TEST
#endif
		_delay_us( OWDELAYPULLUP );				// Czas na odpowied w trybie uart
		// loop to do the search
		do
			{
			// read a bit and its complement
			id_bit = onewireReadBit();
#ifdef OWSEARCHTEST
  LenTx1=1; UDR1=id_bit+'0'; // TEST
#endif
			cmp_id_bit = onewireReadBit();
#ifdef OWSEARCHTEST
  LenTx1=1; UDR1=cmp_id_bit+'0'; // TEST
#endif
			// Sprawd czy brak odpowiedzi ( 0b11 )
			if ((id_bit == 1) && (cmp_id_bit == 1))	break;
			else
				{
				if (id_bit != cmp_id_bit)
					{
					// odpowied 0b01 wic ten bit zgodny we wszystkich ukadach albo tylko jeden na magistrali
					search_direction = id_bit; // bit write value for search
					}
				else
					{
					// odpowied 0b00 wic odpowiedziay conajmniej dwa ukady
					onewireMany = TRUE;
					// if this discrepancy if before the Last Discrepancy
					// on a previous next then pick the same as last time
					if (id_bit_number < LastDiscrepancy)
						{
						search_direction = ((OW_SEARCH_ROM_NO[rom_byte_number] & rom_byte_mask) > 0);
						}
					else
						{
						// if equal to last pick 1, if not then pick 0
						search_direction = (id_bit_number == LastDiscrepancy);
						}
					// if 0 was picked then record its position in LastZero
					if (search_direction == 0)
						{
						last_zero = id_bit_number;
						// check for Last discrepancy in family
						if (last_zero < 9) LastFamilyDiscrepancy = last_zero;
						}
					}
					// set or clear the bit in the ROM byte rom_byte_number
					// with mask rom_byte_mask
					if (search_direction == 1) OW_SEARCH_ROM_NO[rom_byte_number] |= rom_byte_mask;
					else { OW_SEARCH_ROM_NO[rom_byte_number] &= ~rom_byte_mask; }
					// serial number search direction write bit
					onewireWriteBit(search_direction);
					_delay_us( OWOVT_BIT );				// Czas na odpowied w trybie UART
#ifdef OWSEARCHTEST
  LenTx1=1; UDR1=search_direction+'a'; // TEST
#endif
					// increment the byte counter id_bit_number
					// and shift the mask rom_byte_mask
					id_bit_number++;
					rom_byte_mask <<= 1;
					// if the mask is 0 then go to new SerialNum byte rom_byte_number and reset mask
					if (rom_byte_mask == 0)
						{
						docrc8(OW_SEARCH_ROM_NO[rom_byte_number]); // accumulate the CRC
						rom_byte_number++;
						rom_byte_mask = 1;
						}
					}
				}
			while(rom_byte_number < 8); // loop until through all ROM bytes 0-7
			// if the search was successful then
			if (!((id_bit_number < 65) || (crc8 != 0)))
				{
				// search successful so set LastDiscrepancy,LastDeviceFlag,search_result
				LastDiscrepancy = last_zero;
				// check for last device
				if (LastDiscrepancy == 0) LastDeviceFlag = TRUE;
				search_result = TRUE;
				onewireCount++;
				}
		}

	// if no device found then reset counters so next 'search' will be like a first
	if (!search_result || !OW_SEARCH_ROM_NO[0])
		{
		LastDiscrepancy = 0;
		LastDeviceFlag = FALSE;
		LastFamilyDiscrepancy = 0;
		search_result = FALSE;
		}

	#if ONEWIRE_IRQ == 2
	  SREG = cSREG;
	#endif

#ifdef OWSEARCHTEST
  LenTx1=1; UDR1=search_result+'E'; // TEST
#endif


	if ( !search_result) onewireReset();	// jeli koniec szukania to zresetuj magistral
	return( search_result );
}
/*
static unsigned char dscrc_table[] = {
0, 94,188,226, 97, 63,221,131,194,156,126, 32,163,253, 31, 65,
157,195, 33,127,252,162, 64, 30, 95, 1,227,189, 62, 96,130,220,
35,125,159,193, 66, 28,254,160,225,191, 93, 3,128,222, 60, 98,
190,224, 2, 92,223,129, 99, 61,124, 34,192,158, 29, 67,161,255,
70, 24,250,164, 39,121,155,197,132,218, 56,102,229,187, 89, 7,
219,133,103, 57,186,228, 6, 88, 25, 71,165,251,120, 38,196,154,
101, 59,217,135, 4, 90,184,230,167,249, 27, 69,198,152,122, 36,
248,166, 68, 26,153,199, 37,123, 58,100,134,216, 91, 5,231,185,
140,210, 48,110,237,179, 81, 15, 78, 16,242,172, 47,113,147,205,
17, 79,173,243,112, 46,204,146,211,141,111, 49,178,236, 14, 80,
175,241, 19, 77,206,144,114, 44,109, 51,209,143, 12, 82,176,238,
50,108,142,208, 83, 13,239,177,240,174, 76, 18,145,207, 45,115,
202,148,118, 40,171,245, 23, 73, 8, 86,180,234,105, 55,213,139,
87, 9,235,181, 54,104,138,212,149,203, 41,119,244,170, 72, 22,
233,183, 85, 11,136,214, 52,106, 43,117,151,201, 74, 20,246,168,
116, 42,200,150, 21, 75,169,247,182,232, 10, 84,215,137,107, 53};
*/
//--------------------------------------------------------------------------
// Calculate the CRC8 of the byte value provided with the current
// global 'crc8' value.
// Returns current global crc8 value
//
unsigned char docrc8(unsigned char value)
{
// See Application Note 27
// TEST BUILD

//crc8 = dscrc_table[crc8 ^ value];
crc8=onewireCrc8update(crc8, value);

return crc8;
}
